"""

MOVIE2GCODE

copyright Cedric DOutriaux
may 2014

licence creative commons cc-by sa


TODO

-mise en page  :
    
    choix fichier slicer
    
    choix remplissage
    
    
- lancement du calcul (calcuLoop)
    
    

-export du script



"""
import wx, os, PIL.Image ,sys ,thread,threading

#global variables 
bmpList=""

#------------------------------------------------------------------------------

def BitmapFromFile( imgFilename ) :
    """ The following PIL image conversion must first go to a wx.Image.
    The wx.Image is always finally converted to a wx.Bitmap regardless of whether or not
    there is any image transparency information to be handled.
    This is because only a wxBitmap can be directly displayed - a wxImage can't !

    The module Win32IconImagePlugin.py must be imported to get PIL to properly read
    paletted images with a mask (binary valued transparency). All .ICO and some .PNG files
    may have paletted image data with mask transparency. See:

    Win32IconImagePlugin - Alternate PIL plugin for dealing with Microsoft .ico files.
    http://code.google.com/p/casadebender/wiki/Win32IconImagePlugin
    """
    pilImg = PIL.Image.open( imgFilename )
    
    # The following is equivalent to "wxImg = wx.EmptyImage( pilImg.size[0], pilImg.size[1] )".
    wxImg = wx.EmptyImage( *pilImg.size )   # Always created with no transparency plane.

    # Determine if the image file has any inherent transparency.
    pilMode = pilImg.mode     # Will usually be either "RGB" or "RGBA", but may be others.
    pilHasAlpha =1
   # pilHasAlpha = pilImg.mode[-1] == 'A'
    if pilHasAlpha :
        
        # First extract just the RGB data from the data string and insert it into wx.Image .
        pilRgbStr = pilImg.convert( 'RGB').tostring()
        wxImg.SetData( pilRgbStr )

        # To convert to a wx.Image with alpha the pilImg mode needs to be "RGBA".
        # So, add an alpha layer even if the original file image doesn't have any transparency info.
        # If the file image doesn't have any transparency, the resulting wx.Image (and, finally, the wx.Bitmap)
        # will be 100% opaque just like the file image.
        pilImgStr = pilImg.convert( 'RGBA' ).tostring()    # Harmless if original image mode is already "RGBA".

        # Now, extract just the alpha data and insert it.
        pilAlphaStr = pilImgStr[3::4]    # start at byte index 3 with a stride (byte skip) of 4.
        wxImg.SetAlphaData( pilAlphaStr )

    #end if

    wxBmap = wxImg.ConvertToBitmap()     # Equivalent result:   wxBmap = wx.BitmapFromImage( wxImg )
    return wxBmap

#end def






class TestFrame(wx.Frame):
    def __init__(self, *args, **kwargs):
        wx.Frame.__init__(self, *args, **kwargs)

        # there needs to be an "Images" directory with one or more jpegs in it in the
        # current working directory for this to work
        GetBmpList(imagesDir) # get all the jpegs in the Images directory
        self.CurrentBmp = 0

        self.MaxImageSize = 320
        


        v = wx.Button(self, -1, "Vectorise")
        v.Bind(wx.EVT_BUTTON, self.Vectorise)

        #indicators
        self.currentImage=wx.StaticText(self,-1,'0/0')
        self.currentDir=wx.StaticText(self,-1,'images')
        
        self.outputDim=wx.StaticText(self,-1,'output Dimensions')
        
        #STL block
        self.STLDim=wx.StaticText(self,-1,'STL : 0 cm')
        
        self.openScadBt=wx.Button(self, -1, "open SCAD file")
        self.openScadBt.Bind(wx.EVT_BUTTON, self.openScadFile)
        
        self.scadBlock= wx.BoxSizer(wx.HORIZONTAL)
        self.scadBlock.Add(self.STLDim, flag=wx.ALIGN_LEFT)
        self.scadBlock.Add(self.openScadBt, flag=wx.ALIGN_LEFT)
        
        #textfields
        #display of potrace command
        self.VectorisecommandDisplay = wx.TextCtrl(self, style=wx.TE_LEFT,size=(600, 23))
        
        #choose of openscad scale
        self.STLScale = wx.TextCtrl(self, style=wx.TE_LEFT,size=(90, 23))
        self.STLScale.SetValue('15')
        
        self.ScaleLabel=wx.StaticText(self,-1,' STL scale :')
        
        self.scaleSelect = wx.BoxSizer(wx.HORIZONTAL)
        self.scaleSelect.Add(self.ScaleLabel, flag=wx.ALIGN_LEFT)
        self.scaleSelect.Add(self.STLScale, flag=wx.EXPAND)
        
        #choose of Layer height
        self.LayerH = wx.TextCtrl(self, style=wx.TE_PROCESS_ENTER,size=(90, 23))
        self.LayerH.SetValue('0.15')
        
        self.LayerHLabel=wx.StaticText(self,-1,' Layer height (mm) :')
        
        self.LayerHSelect = wx.BoxSizer(wx.HORIZONTAL)
        self.LayerHSelect.Add(self.LayerHLabel, flag=wx.ALIGN_LEFT)
        self.LayerHSelect.Add(self.LayerH, flag=wx.EXPAND)
        self.Bind(wx.EVT_SCROLL, self.slideControl)
        
        self.TotalHeight=wx.StaticText(self,-1,'Total height :')
        self.LayerH.Bind(wx.EVT_TEXT_ENTER,self.changeHeight)
        #refresh total height
        self.changeHeight()
        
        
        
        # sliders       
        self.threshold = 50
        
        self.thresholdSlider=wx.Slider(self, -1, self.threshold, 0, 100, size=(320, -1),style=wx.SL_LABELS)

        self.turdsize=1 
        self.turdsizeSlider=wx.Slider(self, -1, self.turdsize, 0, 1000, size=(320, -1),style=wx.SL_LABELS)
        self.Bind(wx.EVT_SCROLL, self.slideControl)
        
        #images
        # starting with an EmptyBitmap, the real one will get put there
        # by the call to .DisplayNext()
        self.Image = wx.StaticBitmap(self, bitmap=wx.EmptyBitmap(self.MaxImageSize, self.MaxImageSize))

        
        
        
        self.Image2 = wx.StaticBitmap(self, bitmap=wx.EmptyBitmap(self.MaxImageSize, self.MaxImageSize))

        self.DisplayNext(1)
        #controls
        self.frw = wx.Button(self, -1, ">>")
        self.frw.Bind(wx.EVT_BUTTON, self.nextImage)
        
        self.bkw = wx.Button(self, -1, "<<")
        self.bkw.Bind(wx.EVT_BUTTON, self.previousImage)
        
        #choose source folder
        self.chf = wx.Button(self, -1, "sourceDir")
        self.chf.Bind(wx.EVT_BUTTON, self.chooseFolder)
        
        
        #launch calcul
        self.lcl = wx.Button(self, -1, "do Calculs")
        self.lcl.Bind(wx.EVT_BUTTON, self.launchMultithread)
        

        

        
     
        
        

        
        
        
        #the maingrid
        grid=wx.FlexGridSizer(6, 4, 0, 0)
        #fill it
        grid.AddMany([(self.chf, wx.EXPAND),(self.currentDir, wx.EXPAND),(self.currentImage, wx.EXPAND), (wx.StaticText(self), wx.EXPAND), 
        (self.bkw,1, wx.EXPAND),(self.Image, 1, wx.EXPAND), (self.Image2, 1, wx.EXPAND),(self.frw, 1, wx.EXPAND),
        (wx.StaticText(self,label='threshold'), wx.EXPAND), (self.thresholdSlider,1, 1, wx.EXPAND),(v, 1, wx.EXPAND),(wx.StaticText(self), wx.EXPAND),
        (wx.StaticText(self,label='turdsize'), wx.EXPAND),(self.turdsizeSlider,1, 1, wx.EXPAND),(self.VectorisecommandDisplay, wx.EXPAND),(wx.StaticText(self), wx.EXPAND),
        (self.outputDim, wx.EXPAND),(self.scaleSelect, wx.EXPAND),(self.scadBlock, wx.EXPAND),(wx.StaticText(self), wx.EXPAND),
        (self.LayerHSelect, wx.EXPAND),(self.TotalHeight, wx.EXPAND),(self.lcl, wx.EXPAND)])
        box = wx.BoxSizer(wx.HORIZONTAL)
        box.Add(grid, proportion=1, flag=wx.ALL|wx.EXPAND, border=15)
    

        self.SetSizerAndFit(box)
        
        wx.EVT_CLOSE(self, self.OnCloseWindow)
     
     
    def  openScadFile (self, event=None):
        #generate and open the scad file
        eps2dxf="pstoedit -dt -f dxf:-polyaslines /tmp/movie2gcode.test.eps /tmp/movie2gcode.test.dxf"
        os.system(eps2dxf)
        ScadFilecontent="intersection(){\n\
            translate([0,0,-5])cube(["+str(self.stlW)+","+str(self.stlW)+",10]);\n\
            scale(["+self.STLScale.GetValue()+","+self.STLScale.GetValue()+",1])\n\
            linear_extrude(height = "+self.LayerH.GetValue()+", center = false, convexity = 10)\n\
            import (file = \"/tmp/movie2gcode.test.dxf\");\n\
            }\n\
            translate([0,0,0])cube(0.05);\n\
            translate(["+str(self.stlW)+","+str(self.stlW)+",0])cube([0.05,0.05,0.14]);"
        #save file
        print 'opening scad file...'
        _scadfile=open('/tmp/movie2gcode.test.scad','w')
        _scadfile.write(ScadFilecontent) 
        _scadfile.close() 
        os.system("openscad /tmp/movie2gcode.test.scad")
        
      
    def  changeHeight(self, event=None):
        tHeight=float(self.LayerH.GetValue())*len(bmpList)
        self.TotalHeight.SetLabel("Total Height : "+str(tHeight)+" mm")
        
        
        
    
    def   chooseFolder(self, event=None):
        dialog = wx.DirDialog(None, "Choose an images source directory (bmp):",style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
        if dialog.ShowModal() == wx.ID_OK:
            print dialog.GetPath()
            bmpList = GetBmpList(dialog.GetPath())
            self.currentDir.SetLabel(dialog.GetPath())
            self.CurrentBmp=0
            self.DisplayNext(direction=1)
            self.changeHeight()
        dialog.Destroy()
        
    def nextImage(self, event=None):
        self.DisplayNext(direction=1)
        
    def previousImage(self, event=None):
        self.DisplayNext(direction=-1) 
        
    def DisplayNext(self, event=None,direction=1):
        # load the image
        #print "------------------------------"+str(self.CurrentBmp)
        #print "------------------------------"+bmpList
        Img = wx.Image(bmpList[self.CurrentBmp], wx.BITMAP_TYPE_BMP  )
        # scale the image, preserving the aspect ratio
        W = Img.GetWidth()
        H = Img.GetHeight()
        if W > H:
            NewW = self.MaxImageSize
            NewH = self.MaxImageSize * H / W
        else:
            NewH = self.MaxImageSize
            NewW = self.MaxImageSize * W / H
        Img = Img.Scale(NewW,NewH)
 
        # convert it to a wx.Bitmap, and put it on the wx.StaticBitmap
        self.Image.SetBitmap(wx.BitmapFromImage(Img))

        # You can fit the frame to the image, if you want.
        #self.Fit()
        #self.Layout()
        
        #update vectorised version of the image
        self.slideControl()
        #refresh display
        self.Refresh()
        
        self.currentImage.SetLabel(str(self.CurrentBmp)+"/"+str(len(bmpList)))

        self.CurrentBmp += direction
        if self.CurrentBmp > len(bmpList) -1 and direction==1:
            self.CurrentBmp = 0
        elif self.CurrentBmp < 0 and  direction==-1:
            self.CurrentBmp = len(bmpList) -1
    
    def slideControl(self,event=None):
        # -k = light level
        # -t turdsize
        self.turdsize=self.turdsizeSlider.GetValue()
        self.threshold=self.thresholdSlider.GetValue()
        
        #build the command line
        self.Vectorisecommand= "potrace  -k"+str(float(self.threshold)/100)+" -t "+str(self.turdsize)+" -B-0.25 -o /tmp/movie2gcode.test.eps  -e "+bmpList[self.CurrentBmp]
        self.VectorisecommandDisplay.SetValue(self.Vectorisecommand)
        self.Vectorise()
    
    def Vectorise(self,event=None):
        
        #get the current commandline
        self.Vectorisecommand=self.VectorisecommandDisplay.GetValue()
        
        #vectorise
        os.system(self.Vectorisecommand)
        #display result
        epsImage=BitmapFromFile( '/tmp/movie2gcode.test.eps' ) 
        self.Image2.SetBitmap(epsImage )
        #display size
        W = epsImage.GetWidth()
        H = epsImage.GetHeight()
        self.outputDim.SetLabel("Ouput Dim : "+str(W)+"/"+str(H))
        #STL size
        scale=float(self.STLScale.GetValue())
        self.stlW=float(W/50)*scale
        self.stlH=float(H/50)*scale
        self.STLDim.SetLabel("STL : "+str(self.stlW)+"/"+str(self.stlH)+" mm")
      
    def launchMultithread(self,event=None):
        #""""""""""""""""""""""""""" first convert BMP to STL
        print "----------------------------starting calcul"
        
        #make STL dir
        if not os.path.exists(imagesDir+"/stl"):
            os.makedirs(imagesDir+"/stl")
        
        
        #divide the calcul for each thread
        blocks=len(bmpList)/threads
        threadslist=[]
        for num in range(1,threads+1):
            start_id=blocks*(num-1)
            
            #avoid loosing spare images
            if num==threads:
                end_id=len(bmpList)-1
            else:
                end_id=blocks*num-1
            
            print "go calcul of images "+str(start_id)+" to "+ str(end_id)
            threadslist.append(myThread(start_id, end_id))
        
        
        for t in threadslist:
            t.run()
        
        #wait for threads finish
        for t in threadslist:            
            while t.isAlive():
                print ""#wait               
        print "Exiting Main Thread"

    def OnCloseWindow(self, event):
        self.Destroy()

class myThread (threading.Thread):
    #thread for batch openscad calcul
    def __init__(self, startid, endid):
        threading.Thread.__init__(self)
        #self.threadID = threadID
        self.startid = startid
        self.endid = endid
        
    def run(self):
        print "Starting calcul from : " + str(self.startid)
        calculLoop(self.startid, self.endid, )
        print "Exiting after        : " + str(self.endid)

def calculLoop(startid,endid):
    for imgId in range(startid,endid+1):
        print str(bmpList[imgId])+"/"+str(endid)



def GetBmpList(dir):
    bmps = [f for f in os.listdir(dir) if f[-4:] == ".bmp"]
    bmps.sort()
    # print "bmps are:", bmps
    global bmpList
    bmpList= [os.path.join(dir, f) for f in bmps]
    

class App(wx.App):
    def OnInit(self):

        frame = TestFrame(None, -1, "Movie 2 Gcode", wx.DefaultPosition,(450,200))
        self.SetTopWindow(frame)
        frame.Show(True)
        return True

if __name__ == "__main__":
    print "usage : Movie2Gcode.py [directory containing BMP sequence] [number of threads]"
    if len(sys.argv) < 2:
        print("give a directory containing BMP sequence")
        sys.exit(1)
    imagesDir=sys.argv[1]
    threads=1
    if len(sys.argv) > 2: 
        threads=int(sys.argv[2])
    print "_______load folder "+imagesDir
    print "_______number of threads "+str(threads)
    app = App(0)
    app.MainLoop()
